/*MT*
    
    MediaTomb - http://www.mediatomb.org/
    
    xpath.h - this file is part of MediaTomb.
    
    Copyright (C) 2005 Gena Batyan <bgeradz@mediatomb.org>,
                       Sergey 'Jin' Bostandzhyan <jin@mediatomb.org>
    
    Copyright (C) 2006-2007 Gena Batyan <bgeradz@mediatomb.org>,
                            Sergey 'Jin' Bostandzhyan <jin@mediatomb.org>,
                            Leonhard Wimmer <leo@mediatomb.org>
    
    MediaTomb is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2
    as published by the Free Software Foundation.
    
    MediaTomb is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    version 2 along with MediaTomb; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    
    $Id: xpath.h 971 2007-01-11 19:24:21Z lww $
*/

/// \file xpath.h

#ifndef __XPATH_H__
#define __XPATH_H__

#include "zmmf/zmmf.h"
#include "mxml/mxml.h"

class XPath : public zmm::Object
{
protected:
    zmm::Ref<mxml::Element> context;
public:
    XPath(zmm::Ref<mxml::Element> context);
    zmm::String getText(zmm::String xpath);
    zmm::Ref<mxml::Element> getElement(zmm::String xpath);

    static zmm::String getPathPart(zmm::String xpath);
    static zmm::String getAxisPart(zmm::String xpath);
    static zmm::String getAxis(zmm::String axisPart);
    static zmm::String getSpec(zmm::String axisPart);
protected:
    zmm::Ref<mxml::Element> elementAtPath(zmm::String path);
};

#endif // __XPATH_H__

